/* Generated from Salut-specific extensions to the Telepathy interfaces

Copyright (C) 2007 Collabora Limited

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 */

#ifdef __cplusplus
extern "C" {
#endif


/**
 * SalutFileTransferState:
 * @SALUT_FILETRANSFER_STATE_LOCALPENDING: <![CDATA[           The file transfer is waiting to be accepted/closed locally.         ]]>
 * @SALUT_FILETRANSFER_STATE_REMOTEPENDING: <![CDATA[           The file transfer is waiting to be accepted/closed remotely.         ]]>
 * @SALUT_FILETRANSFER_STATE_OPEN: <![CDATA[           The file transfer is open for traffic.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    SALUT_FILETRANSFER_STATE_LOCALPENDING = 0,
    SALUT_FILETRANSFER_STATE_REMOTEPENDING = 1,
    SALUT_FILETRANSFER_STATE_OPEN = 2,
} SalutFileTransferState;

/**
 * NUM_SALUT_FILETRANSFER_STATES:
 *
 * 1 higher than the highest valid value of #SalutFileTransferState.
 */
#define NUM_SALUT_FILETRANSFER_STATES (2+1)


/**
 * SalutFileTransferDirection:
 * @SALUT_FILETRANSFER_DIRECTION_INCOMING: <![CDATA[           The file transfer is for an incoming file, i.e. a file offered           to this client.         ]]>
 * @SALUT_FILETRANSFER_DIRECTION_OUTGOING: <![CDATA[           The file transfer is for an outgoing file, i.e. a file offered           by this client.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    SALUT_FILETRANSFER_DIRECTION_INCOMING = 0,
    SALUT_FILETRANSFER_DIRECTION_OUTGOING = 1,
} SalutFileTransferDirection;

/**
 * NUM_SALUT_FILETRANSFER_DIRECTIONS:
 *
 * 1 higher than the highest valid value of #SalutFileTransferDirection.
 */
#define NUM_SALUT_FILETRANSFER_DIRECTIONS (1+1)


/**
 * SalutTubeType:
 * @SALUT_TUBE_TYPE_DBUS: <![CDATA[           An ordered reliable transport, for transporting D-Bus traffic.            For each D-Bus tube, the connection manager listens on a D-Bus           server address, as detailed in the D-Bus specification. On this           address, it emulates a bus upon which each tube participant appears           as an endpoint. The service name of a D-Bus tube should be a           well-known D-Bus service name, of the form com.example.ServiceName.            The objects and interfaces which are expected to exist on the           emulated bus depend on the well-known name; typically, either the           participant who initiated the tube is expected to export the same           objects/interfaces that would be exported by a service of that name           on a bus, or all participants are expected to export those           objects/interfaces.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    SALUT_TUBE_TYPE_DBUS = 0,
} SalutTubeType;

/**
 * NUM_SALUT_TUBE_TYPES:
 *
 * 1 higher than the highest valid value of #SalutTubeType.
 */
#define NUM_SALUT_TUBE_TYPES (0+1)


/**
 * SalutTubeState:
 * @SALUT_TUBE_STATE_LOCAL_PENDING: <![CDATA[           The tube is waiting to be accepted/closed locally.         ]]>
 * @SALUT_TUBE_STATE_REMOTE_PENDING: <![CDATA[           The tube is waiting to be accepted/closed remotely.         ]]>
 * @SALUT_TUBE_STATE_OPEN: <![CDATA[           The tube is open for traffic.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    SALUT_TUBE_STATE_LOCAL_PENDING = 0,
    SALUT_TUBE_STATE_REMOTE_PENDING = 1,
    SALUT_TUBE_STATE_OPEN = 2,
} SalutTubeState;

/**
 * NUM_SALUT_TUBE_STATES:
 *
 * 1 higher than the highest valid value of #SalutTubeState.
 */
#define NUM_SALUT_TUBE_STATES (2+1)



#ifdef __cplusplus
}
#endif

