/*
 * _gen/svc-Channel_Type_Tubes.c - Source for SalutSvcChannelTypeTubes
 *
 * 
    Copyright (C) 2007 Collabora Limited
  
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Channel_Type_Tubes.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_salut_svc_channel_type_tubes_object_info;
struct _SalutSvcChannelTypeTubesClass {
    GObjectClass parent_class;
    salut_svc_channel_type_tubes_accept_tube_impl accept_tube;
    salut_svc_channel_type_tubes_close_tube_impl close_tube;
    salut_svc_channel_type_tubes_get_available_tube_types_impl get_available_tube_types;
    salut_svc_channel_type_tubes_get_d_bus_names_impl get_d_bus_names;
    salut_svc_channel_type_tubes_get_d_bus_server_address_impl get_d_bus_server_address;
    salut_svc_channel_type_tubes_list_tubes_impl list_tubes;
    salut_svc_channel_type_tubes_offer_tube_impl offer_tube;
};

enum {
    SIGNAL_DBusNamesChanged,
    SIGNAL_NewTube,
    SIGNAL_TubeClosed,
    SIGNAL_TubeStateChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
salut_svc_channel_type_tubes_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_DBusNamesChanged] =
      g_signal_new ("d-bus-names-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _salut_ext_marshal_VOID__UINT_BOXED_BOXED,
                    G_TYPE_NONE, 3, G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_INVALID)))), DBUS_TYPE_G_UINT_ARRAY);

      signals[SIGNAL_NewTube] =
      g_signal_new ("new-tube",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _salut_ext_marshal_VOID__UINT_UINT_UINT_STRING_BOXED_UINT,
                    G_TYPE_NONE, 6, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_UINT);

      signals[SIGNAL_TubeClosed] =
      g_signal_new ("tube-closed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__UINT,
                    G_TYPE_NONE, 1, G_TYPE_UINT);

      signals[SIGNAL_TubeStateChanged] =
      g_signal_new ("tube-state-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _salut_ext_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (salut_svc_channel_type_tubes_get_type (), &dbus_glib_salut_svc_channel_type_tubes_object_info);
    }
}

GType
salut_svc_channel_type_tubes_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (SalutSvcChannelTypeTubesClass),
      salut_svc_channel_type_tubes_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "SalutSvcChannelTypeTubes", &info, 0);
  }

  return type;
}


/**
 * salut_svc_channel_type_tubes_accept_tube_impl
 * @self: The object implementing this interface
 * @id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method AcceptTube
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_accept_tube (SalutSvcChannelTypeTubes *self,
                                          guint id,
                                          DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_accept_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->accept_tube);
  if (impl)
    (impl) (self, id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * salut_svc_channel_type_tubes_implement_accept_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcceptTube method
 *
 * Register an implementation for the AcceptTube method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_accept_tube (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_accept_tube_impl impl)
{
  klass->accept_tube = impl;
}


/**
 * salut_svc_channel_type_tubes_close_tube_impl
 * @self: The object implementing this interface
 * @id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method CloseTube
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_close_tube (SalutSvcChannelTypeTubes *self,
                                         guint id,
                                         DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_close_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->close_tube);
  if (impl)
    (impl) (self, id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * salut_svc_channel_type_tubes_implement_close_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CloseTube method
 *
 * Register an implementation for the CloseTube method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_close_tube (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_close_tube_impl impl)
{
  klass->close_tube = impl;
}


/**
 * salut_svc_channel_type_tubes_get_available_tube_types_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetAvailableTubeTypes
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_get_available_tube_types (SalutSvcChannelTypeTubes *self,
                                                       DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_get_available_tube_types_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->get_available_tube_types);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * salut_svc_channel_type_tubes_implement_get_available_tube_types:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetAvailableTubeTypes method
 *
 * Register an implementation for the GetAvailableTubeTypes method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_get_available_tube_types (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_get_available_tube_types_impl impl)
{
  klass->get_available_tube_types = impl;
}


/**
 * salut_svc_channel_type_tubes_get_d_bus_names_impl
 * @self: The object implementing this interface
 * @id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetDBusNames
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_get_d_bus_names (SalutSvcChannelTypeTubes *self,
                                              guint id,
                                              DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_get_d_bus_names_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->get_d_bus_names);
  if (impl)
    (impl) (self, id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

#define salut_svc_channel_type_tubes_get_dbus_names salut_svc_channel_type_tubes_get_d_bus_names

/**
 * salut_svc_channel_type_tubes_implement_get_d_bus_names:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetDBusNames method
 *
 * Register an implementation for the GetDBusNames method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_get_d_bus_names (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_get_d_bus_names_impl impl)
{
  klass->get_d_bus_names = impl;
}


/**
 * salut_svc_channel_type_tubes_get_d_bus_server_address_impl
 * @self: The object implementing this interface
 * @id: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetDBusServerAddress
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_get_d_bus_server_address (SalutSvcChannelTypeTubes *self,
                                                       guint id,
                                                       DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_get_d_bus_server_address_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->get_d_bus_server_address);
  if (impl)
    (impl) (self, id, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

#define salut_svc_channel_type_tubes_get_dbus_server_address salut_svc_channel_type_tubes_get_d_bus_server_address

/**
 * salut_svc_channel_type_tubes_implement_get_d_bus_server_address:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetDBusServerAddress method
 *
 * Register an implementation for the GetDBusServerAddress method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_get_d_bus_server_address (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_get_d_bus_server_address_impl impl)
{
  klass->get_d_bus_server_address = impl;
}


/**
 * salut_svc_channel_type_tubes_list_tubes_impl
 * @self: The object implementing this interface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method ListTubes
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_list_tubes (SalutSvcChannelTypeTubes *self,
                                         DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_list_tubes_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->list_tubes);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * salut_svc_channel_type_tubes_implement_list_tubes:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ListTubes method
 *
 * Register an implementation for the ListTubes method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_list_tubes (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_list_tubes_impl impl)
{
  klass->list_tubes = impl;
}


/**
 * salut_svc_channel_type_tubes_offer_tube_impl
 * @self: The object implementing this interface
 * @type: FIXME: document args in genginterface
 * @service: FIXME: document args in genginterface
 * @parameters: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method OfferTube
 * on interface org.freedesktop.Telepathy.Channel.Type.Tubes
 */
static void
salut_svc_channel_type_tubes_offer_tube (SalutSvcChannelTypeTubes *self,
                                         guint type,
                                         const gchar *service,
                                         GHashTable *parameters,
                                         DBusGMethodInvocation *context)
{
  salut_svc_channel_type_tubes_offer_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_TUBES_GET_CLASS (self)->offer_tube);
  if (impl)
    (impl) (self, type, service, parameters, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * salut_svc_channel_type_tubes_implement_offer_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the OfferTube method
 *
 * Register an implementation for the OfferTube method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
salut_svc_channel_type_tubes_implement_offer_tube (SalutSvcChannelTypeTubesClass *klass, salut_svc_channel_type_tubes_offer_tube_impl impl)
{
  klass->offer_tube = impl;
}

/**
 * salut_svc_channel_type_tubes_emit_d_bus_names_changed:
 * @instance: An object implementing this interface
 * @id: FIXME: document args in genginterface
 * @added: FIXME: document args in genginterface
 * @removed: FIXME: document args in genginterface
 *
 * Emit the DBusNamesChanged D-Bus signal from @instance with the given arguments.
 */
void salut_svc_channel_type_tubes_emit_d_bus_names_changed (gpointer instance,
    const guint  id,
    const GPtrArray * added,
    const GArray * removed)
{
  g_assert (SALUT_IS_SVC_CHANNEL_TYPE_TUBES (instance));
  g_signal_emit (instance, signals[SIGNAL_DBusNamesChanged], 0, id, added, removed);
}

/**
 * salut_svc_channel_type_tubes_emit_new_tube:
 * @instance: An object implementing this interface
 * @id: FIXME: document args in genginterface
 * @initiator: FIXME: document args in genginterface
 * @type: FIXME: document args in genginterface
 * @service: FIXME: document args in genginterface
 * @parameters: FIXME: document args in genginterface
 * @state: FIXME: document args in genginterface
 *
 * Emit the NewTube D-Bus signal from @instance with the given arguments.
 */
void salut_svc_channel_type_tubes_emit_new_tube (gpointer instance,
    const guint  id,
    const guint  initiator,
    const guint  type,
    const gchar * service,
    const GHashTable * parameters,
    const guint  state)
{
  g_assert (SALUT_IS_SVC_CHANNEL_TYPE_TUBES (instance));
  g_signal_emit (instance, signals[SIGNAL_NewTube], 0, id, initiator, type, service, parameters, state);
}

/**
 * salut_svc_channel_type_tubes_emit_tube_closed:
 * @instance: An object implementing this interface
 * @id: FIXME: document args in genginterface
 *
 * Emit the TubeClosed D-Bus signal from @instance with the given arguments.
 */
void salut_svc_channel_type_tubes_emit_tube_closed (gpointer instance,
    const guint  id)
{
  g_assert (SALUT_IS_SVC_CHANNEL_TYPE_TUBES (instance));
  g_signal_emit (instance, signals[SIGNAL_TubeClosed], 0, id);
}

/**
 * salut_svc_channel_type_tubes_emit_tube_state_changed:
 * @instance: An object implementing this interface
 * @id: FIXME: document args in genginterface
 * @state: FIXME: document args in genginterface
 *
 * Emit the TubeStateChanged D-Bus signal from @instance with the given arguments.
 */
void salut_svc_channel_type_tubes_emit_tube_state_changed (gpointer instance,
    const guint  id,
    const guint  state)
{
  g_assert (SALUT_IS_SVC_CHANNEL_TYPE_TUBES (instance));
  g_signal_emit (instance, signals[SIGNAL_TubeStateChanged], 0, id, state);
}

#include "_gen/svc-Channel_Type_Tubes-glue.h"

